{ "status": "success", "message": "Your request has been accepted and will be processed soon."}
Track User
This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.
{ "status": "success", "message": "Your request has been accepted and will be processed soon."}
For more information about trackable user attributes, reserved keys, and general data information, refer to the Data Overview.
If you have Portfolio enabled for your workspace, you must pass project_code in the API endpoint. This identifies which project a user or event belongs to. For more information, refer to Portfolio: Data Ingestion and Management.
Unsetting Attributes is an Early Access feature. To enable it for your account, contact your MoEngage Customer Success Manager (CSM) or the Support team.
Authentication is done via Basic Auth. This requires a base64-encoded string of your credentials in the format 'username:password'.
Username: Use your MoEngage workspace ID (also known as the App ID). You can find it in the MoEngage dashboard at Settings > Account > APIs > Workspace ID (earlier app id).
Password: Use your API Key, which you can find within the Data tile.
Note: After you generate and save the Data API Key, DO NOT generate a new key unless there is a security breach. After you generate a different Data API key and save it, the authentication will start failing. You must update your existing data tracking.
For more information on authentication and getting your credentials, refer here.
Data APIs also support OAuth 2.0. For more information, refer to OAuth 2.0.
The 'X-Forwarded-For' header is used to specify the IP address of the client that made the request. This header may be added by proxy servers or load balancers. The header value must contain the IP address of the original client that initiated the request. Multiple IP addresses may be specified in the header value, separated by commas.
This is the Workspace ID of your MoEngage account that must be passed with the request. You can find it in the MoEngage dashboard at Settings > Account > APIs > Workspace ID (earlier app id).
This is used to identify the type of request. The value is case-sensitive and must be lowercase (customer). A value with different casing, such as Customer, is not accepted.
The unique identifier is used to identify/create a user in MoEngage. Not mandatory in Identity Resolution enabled workspaces. If the User Identity Resolution feature is enabled in your workspace, the attribute parameters in the payload must contain at least one of the identifiers you have activated in your workspace based on which users in MoEngage will be created, updated, or merged. In the following example, moe_mobile is one of the identifiers in the workspace and is passed in attributes:
This field should be passed in the request when only existing users in MoEngage should be updated.
If this value is passed as true:
Only those users for whom the customer_id from the request payload matches the customer identifier in MoEngage will be updated.
In case of new users (customer_id in the payload does not match any of the existing customer ids in your MoEngage account), they will not be created.
If this value is passed as false:
The user attributes will be updated with the values present in the payload for existing customers.
In case of new users (customer_id in the payload does not match any of the existing customer ids in your MoEngage account), a new customer will be created in the system with the details specified in the payload.
A dictionary containing user attributes to add / update in the user profile.
For example, to track custom attributes of different data types like string, numeric, boolean, and date, pass the following payload where points are a number, expiry_date is a date type attribute, and super_user is a boolean attribute.
Note:
"id", "_id", and "" keywords are blocked and not to be used as user attribute names.
You can not use "moe_" as a prefix while naming user attributes. It is a system prefix and using it might result in periodic blacklisting without prior communication.
For other attributes that are not listed below, use the key-value pairs that you intend to use.
Array Support
If you want to pass an attribute in an array, the appropriate syntax for that is:
"Array_attributeName":["abc","123"]
Update Array Attributes
To update an existing array attribute rather than overwrite it, use addValueToArrayField and removeValueFromArrayField inside the attributes object of a Track User call:
Use this field to clear one or more existing user attributes. Add the name of each attribute you want to unset as a string in the array. Each name must exactly match the attribute name in your workspace. Attribute names that are not found are skipped without an error.
"Your request has been accepted and will be processed soon."
{"docsConfig":{"theme":"mint","$schema":"https://mintlify.com/docs.json","name":"MoEngage","colors":{"primary":"#2E69FF","light":"#6691FF","dark":"#2554CC"},"logo":{"light":"https://mintcdn.com/moengage/VG5pJbeZsDUmdCZM/logo/light.svg?fit=max\u0026auto=format\u0026n=VG5pJbeZsDUmdCZM\u0026q=85\u0026s=28ca5909311cb6ffe01738e1503b5e64","dark":"https://mintcdn.com/moengage/VG5pJbeZsDUmdCZM/logo/dark.svg?fit=max\u0026auto=format\u0026n=VG5pJbeZsDUmdCZM\u0026q=85\u0026s=728a767d8fb8d3434575a28de18d08c5","href":"https://www.moengage.com/docs/"},"favicon":"https://mintcdn.com/moengage/bJi_ZHRHKldZCdcW/logo/favicon.svg?fit=max\u0026auto=format\u0026n=bJi_ZHRHKldZCdcW\u0026q=85\u0026s=9d13744d3b616913967983f324947bb5","api":{"examples":{"languages":["curl"]}},"appearance":{"default":"system"},"background":{"decoration":"gradient","color":{"light":"#FFFFFF","dark":"#121212"}},"navbar":{"links":[{"href":"/user-guide/contact-support/raise-a-support-ticket-through-moengage-dashboard","label":"Support"},{"href":"https://www.moengage.com/request-demo","label":"Request Demo"}],"primary":{"type":"button","label":"Dashboard","href":"https://dashboard.moengage.com/"}},"footer":{"socials":{"linkedin":"https://www.linkedin.com/company/moengage","x":"https://x.com/i/flow/login?redirect_after_login=%2Fmoengage","youtube":"https://www.youtube.com/c/MoEngage_Global","facebook":"https://www.facebook.com/moengage","github":"https://github.com/moengage"},"links":[{"header":"Support","items":[{"label":"Contact Support","href":"https://www.moengage.com/docs/user-guide/contact-support/raise-a-support-ticket-through-moengage-dashboard"},{"label":"AIRA Support Bot","href":"https://www.moengage.com/docs/user-guide/contact-support/aira-support-bot/aira-overview"},{"label":"Suggest a Feature","href":"https://www.moengage.com/docs/user-guide/contact-support/suggest-a-feature"},{"label":"System Status","href":"https://status.moengage.com"}]},{"header":"Learn","items":[{"label":"MoEngage Academy","href":"https://academy.moengage.com/student/catalog"},{"label":"Use Cases","href":"https://www.moengage.com/docs/use-cases/introduction"},{"label":"Release Notes","href":"https://www.moengage.com/docs/release-notes/subscribe-to-release-notes"},{"label":"Blog","href":"https://www.moengage.com/blog"}]},{"header":"For AI Tools","items":[{"label":"Setup Guide","href":"https://www.moengage.com/docs/documentation-access-to-agents"},{"label":"llms.txt","href":"https://www.moengage.com/docs/llms.txt"},{"label":"llms-full.txt","href":"https://www.moengage.com/docs/llms-full.txt"}]}]},"seo":{"metatags":{"google-site-verification":"ICNaPDX9oefbF09W1b5_U9PDnlkyfyKSRbIap6_dW6o"},"indexing":"all"},"fonts":{"heading":{"family":"circular","source":"https://app-cdn.moengage.com/images/Fonts/CircularXXWeb-Regular.woff2","format":"woff2"},"body":{"family":"circular","source":"https://app-cdn.moengage.com/images/Fonts/CircularXXWeb-Regular.woff2","format":"woff2"}},"styling":{"eyebrows":"breadcrumbs","latex":true},"contextual":{"options":["copy","view","chatgpt","claude","cursor","vscode"],"display":"header"},"interaction":{"drilldown":true},"navigation":{"languages":[{"language":"en","href":""},{"language":"ja","href":"ja"}]}},"deployment":{"deploymentMetadataValue":{"subdomain":"moengage","hasAudioNarration":false,"actualSubdomain":"moengage","customDomains":["moengage.com"],"gitSource":{"type":"github","owner":"moengage","repo":"moengage-documentation","deployBranch":"main","contentDirectory":"","isPrivate":true,"mountPath":"","label":""},"chroma":{"liveDeploymentHistoryId":"6aecc143001d7bfa48398d64","collectionId":"2b0b7da9-5471-4730-b53e-9284fce40153","schemaVersion":"v3","latestBuiltDeploymentHistoryId":"6aecc143001d7bfa48398d64"},"feedback":{"thumbs":true,"edits":false,"contextualFeedback":{"allowEmail":true},"issues":false,"agentFeedback":true},"entitlements":{"AI_CHAT":{"status":"ENABLED"},"WEB_MCP":{"status":"ENABLED"},"NARRATION":{"status":"ENABLED"}},"buildId":"6aed9e350e1747ee9b9b0553","clientVersion":"0.0.4076","searchFilterCounts":[{"language":"en","tag":"Guide","count":1188},{"language":"ja","tag":"ガイド","count":1180},{"language":"en","tag":"User Guide","count":799},{"language":"ja","tag":"ユーザーガイド","count":798},{"language":"en","tag":"Campaigns and Channels","count":437},{"language":"ja","tag":"キャンペーンとチャネル","count":437},{"language":"en","tag":"Partner Integrations","count":390},{"language":"ja","tag":"パートナー統合","count":383},{"language":"en","tag":"SDKs","count":338},{"language":"en","tag":"Developer Guide (SDKs)","count":327},{"language":"ja","tag":"SDK","count":308},{"language":"ja","tag":"開発者ガイド(SDK)","count":297},{"language":"en","tag":"Use Cases","count":218},{"language":"ja","tag":"ユースケース","count":218},{"language":"en","tag":"API Guide","count":183},{"language":"ja","tag":"APIガイド","count":183},{"language":"en","tag":"Endpoints","count":177},{"language":"ja","tag":"エンドポイント","count":177},{"language":"en","tag":"Release Notes","count":140},{"language":"ja","tag":"リリースノート","count":136}],"searchSettings":{"maxResults":8,"isFiltersEnabled":true}},"assistantConfig":{"enableStarterQuestions":true,"enableContextualStarterQuestions":true,"deflection":{"enabled":false,"type":"email"}},"basePath":"/docs","hasChatPermissions":true,"hasWebMcpPermissions":true,"toggles":[{"name":"kill-isr","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-mintlify-slack","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"agent-integrations-settings","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"rbac-expansion","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-pr-grouping","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"custom-prefix","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"analytics-v7","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"user-flows-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"no-publish-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-onboarding","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"llms-txt-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving-live","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"stripTemperatureMiddleware","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"support-platform-pylon-zendesk","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"snapshot-serving","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"instant-rollback","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications-server","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"granular-notifications","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automations-fable","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fixed-ai-action-pricing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"automation-resolve-merge-conflict","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"scoped-publishing","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"mintql","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"page-level-analytics","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"editor-version-history-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"billing-page-v2","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"full-page-search","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workspace-projects","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"assistant-v5","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"fork-pr-previews","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"revalidation-jwt","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-sso-scim","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"hobby-abuse-scan","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"dashboard-inbox","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-signup","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-dual-write","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"workos-enabled","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"approve-review-flow","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"sso-setup-deadline-banner","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"turbopuffer-serve","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"live-agents","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false},{"name":"comment-mode","enabled":true,"variant":{"name":"disabled","enabled":false,"feature_enabled":true},"impressionData":false}],"starterQuestions":[{"_id":"69a03c84f0b21f38ae93fdfb","deploymentId":"68bea8f8fe02728a34cf2acf","questionText":"How do I track user events?","status":"active","generatedBy":"manual","createdAt":"2026-02-26T12:28:52.454Z","updatedAt":"2026-02-26T12:28:52.454Z","__v":0}],"privacy":{"consentBanner":{"enabled":true}},"googleFontsInlined":false},"customCss":[{"filePath":"style.css","href":"/docs/_mintlify/custom/moengage/0a209f0cf9e21c6c/style.css"}],"page":{"pagePath":"api/user/track-user","slug":"/api/user/track-user","pageMetadata":{"title":"Track User","description":"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customer/{app_id}","href":"/api/user/track-user","autogeneratedByOpenApi":true},"description":{"compiledSource":"\"use strict\";\nconst {jsx: _jsx} = arguments[0];\nconst {useMDXComponents: _provideComponents} = arguments[0];\nfunction _createMdxContent(props) {\n const _components = {\n p: \"p\",\n ..._provideComponents(),\n ...props.components\n };\n return _jsx(_components.p, {\n children: \"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\"\n });\n}\nfunction MDXContent(props = {}) {\n const {wrapper: MDXLayout} = {\n ..._provideComponents(),\n ...props.components\n };\n return MDXLayout ? _jsx(MDXLayout, {\n ...props,\n children: _jsx(_createMdxContent, {\n ...props\n })\n }) : _createMdxContent(props);\n}\nreturn {\n default: MDXContent\n};\n","frontmatter":{},"scope":{}},"pageType":"default","mdx":{"mdxSource":{"compiledSource":"\"use strict\";const{Fragment:_Fragment,jsx:_jsx,jsxs:_jsxs}=arguments[0];const{useMDXComponents:_provideComponents}=arguments[0];function _createMdxContent(props){const _components={a:`a`,code:`code`,li:`li`,p:`p`,ul:`ul`,..._provideComponents(),...props.components},{Heading,Note}=_components;if(!Heading)_missingMdxReference(`Heading`,true);if(!Note)_missingMdxReference(`Note`,true);return _jsxs(_Fragment,{children:[_jsx(Note,{children:_jsxs(_components.ul,{children:[`\n`,_jsxs(_components.li,{children:[`For more information about trackable user attributes, reserved keys, and general data information, refer to the `,_jsx(_components.a,{href:`https://www.moengage.com/docs/api/data/data-overview`,children:`Data Overview`}),`.`]}),`\n`,_jsxs(_components.li,{children:[`If you have `,_jsx(_components.a,{href:`/user-guide/settings/account/portfolio/portfolio`,children:`Portfolio`}),` enabled for your workspace, you must pass `,_jsx(_components.code,{children:`project_code`}),` in the API endpoint. This identifies which project a user or event belongs to. For more information, refer to `,_jsx(_components.a,{href:`/user-guide/data/key-concepts/portfolio-data-ingestion-and-management`,children:`Portfolio: Data Ingestion and Management`}),`.`]}),`\n`,_jsxs(_components.li,{children:[_jsx(_components.a,{href:`/user-guide/data/user-data/unset-user-attributes`,children:`Unsetting Attributes`}),` is an Early Access feature. To enable it for your account, contact your MoEngage Customer Success Manager (CSM) or the Support team.`]}),`\n`]})}),`\n`,_jsx(Heading,{level:`4`,id:`rate-limit`,children:`Rate Limit`}),`\n`,_jsx(_components.p,{children:`A single API request contains one or more user updates. Maintain a rate limit of 10,000 user updates per minute.`})]})}function MDXContent(props={}){const{wrapper:MDXLayout}={..._provideComponents(),...props.components};return MDXLayout?_jsx(MDXLayout,{...props,children:_jsx(_createMdxContent,{...props})}):_createMdxContent(props)}return{default:MDXContent};function _missingMdxReference(id,component){throw new Error(`Expected `+(component?`component`:`object`)+\" `\"+id+\"` to be defined: you likely forgot to import, pass, or provide it.\")}","frontmatter":{},"scope":{"config":{},"pageMetadata":{"title":"Track User","description":"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customer/{app_id}","href":"/api/user/track-user","autogeneratedByOpenApi":true}}},"mdxSourceWithNoJs":null},"mdxExtracts":{"tableOfContents":[{"title":"Rate Limit","slug":"rate-limit","depth":4,"children":[]}],"codeExamples":{}},"jsLinks":["/docs/_mintlify/custom/moengage/992523b3cb2256cd/script.js"],"openApiReferenceData":{"operation":{"tags":["User"],"summary":"Track User","x-mint":{"content":"\u003cNote>\n- For more information about trackable user attributes, reserved keys, and general data information, refer to the [Data Overview](https://www.moengage.com/docs/api/data/data-overview).\n- If you have [Portfolio](/user-guide/settings/account/portfolio/portfolio) enabled for your workspace, you must pass `project_code` in the API endpoint. This identifies which project a user or event belongs to. For more information, refer to [Portfolio: Data Ingestion and Management](/user-guide/data/key-concepts/portfolio-data-ingestion-and-management).\n- [Unsetting Attributes](/user-guide/data/user-data/unset-user-attributes) is an Early Access feature. To enable it for your account, contact your MoEngage Customer Success Manager (CSM) or the Support team.\n\u003c/Note>\n\n#### Rate Limit\nA single API request contains one or more user updates. Maintain a rate limit of 10,000 user updates per minute.\n"},"description":"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.","parameters":["7a316511-e111-4cc7-a5ff-226ef492cb8e","54a4b38d-c149-4a4c-8987-c91c1d9258a5"],"requestBody":"89ff507e-340b-4ebe-9b5f-d7db5ce89895","responses":{"200":"b1c28746-b10b-415e-b7a4-8b8e8e6675e0","400":"bde373a3-93db-41be-aeb6-3fa31376dbfc","401":"4d829247-60d6-4438-bd26-6c085f9b594f","403":"a23c5bd8-2219-4336-8968-d167d7732a8a","413":"8fe761bb-1be1-4649-b2e7-14426483f823","429":"034947e7-3ae3-4dac-8576-7fbb135d91c5","500":"6325a776-c212-4aed-b21a-e7bd70266b7f"},"method":"post","type":"path","servers":["ffebe152-68b4-42de-b875-b5c185adaee9"],"security":["0a8a6282-3380-4bd5-92fc-15578a67160e","3bebacac-7788-4f88-8f53-83638d02c6ca"],"path":"/customer/{app_id}","baseUrlOptions":["https://api-{dc}.moengage.com/v1"],"title":"Track User","codeSamples":[],"requestExampleLanguages":["bash"],"requiredOnlyExamples":false,"requestExampleType":"generated","responseExampleType":"generated"},"dependencies":{"parameters":{"7a316511-e111-4cc7-a5ff-226ef492cb8e":{"name":"app_id","in":"path","required":true,"description":"This is the Workspace ID of your MoEngage account that must be passed with the request. You can find it in the MoEngage dashboard at **Settings** > **Account** > **APIs** > **Workspace ID (earlier app id)**.\n","schema":{"type":"string","example":"VJ0GSMESHMQA3L7WV1EEK3UR","isRequired":true,"description":"This is the Workspace ID of your MoEngage account that must be passed with the request. You can find it in the MoEngage dashboard at **Settings** > **Account** > **APIs** > **Workspace ID (earlier app id)**.\n","uniqueKey":"","typeLabel":"string"}},"54a4b38d-c149-4a4c-8987-c91c1d9258a5":{"name":"X-Forwarded-For","in":"header","required":false,"description":"The 'X-Forwarded-For' header is used to specify the IP address of the client that made the request. This header may be added by proxy servers or load balancers. The header value must contain the IP address of the original client that initiated the request. Multiple IP addresses may be specified in the header value, separated by commas.\n","schema":{"type":"string","example":"203.0.113.195","isRequired":false,"description":"The 'X-Forwarded-For' header is used to specify the IP address of the client that made the request. This header may be added by proxy servers or load balancers. The header value must contain the IP address of the original client that initiated the request. Multiple IP addresses may be specified in the header value, separated by commas.\n","uniqueKey":"","typeLabel":"string"}}},"requestBody":{"required":true,"content":{"application/json":{"schema":{"title":"User","type":"object","required":["type","customer_id"],"properties":{"type":{"type":"string","description":"This is used to identify the type of request. The value is case-sensitive and must be lowercase (`customer`). A value with different casing, such as `Customer`, is not accepted.","enum":["customer"],"isRequired":true,"uniqueKey":"type","typeLabel":"enum\u003cstring>"},"customer_id":{"type":"string","description":"The unique identifier is used to identify/create a user in MoEngage. Not mandatory in [Identity Resolution](/user-guide/data/user-data/unified-identity-identity-resolution) enabled workspaces. If the User Identity Resolution feature is enabled in your workspace, the attribute parameters in the payload must contain at least one of the identifiers you have activated in your workspace based on which users in MoEngage will be created, updated, or merged. In the following example, moe_mobile is one of the identifiers in the workspace and is passed in attributes:\n\n```json\n {\n \"type\": \"customer\",\n \"attributes\": {\"moe_mobile\": \"{{Mobile_Number}}\",\n \"first_name\": \"John\" \n }\n}\n```' \n","isRequired":true,"uniqueKey":"customer_id","typeLabel":"string"},"update_existing_only":{"type":"boolean","default":false,"description":"This field should be passed in the request when only existing users in MoEngage should be updated.\n\n**If this value is passed as true:**\n1. Only those users for whom the customer_id from the request payload matches the customer identifier in MoEngage will be updated.\n2. In case of new users (customer_id in the payload does not match any of the existing customer ids in your MoEngage account), they will not be created.\n\n**If this value is passed as false:**\n1. The user attributes will be updated with the values present in the payload for existing customers.\n2. In case of new users (customer_id in the payload does not match any of the existing customer ids in your MoEngage account), a new customer will be created in the system with the details specified in the payload.\n","uniqueKey":"update_existing_only","typeLabel":"boolean"},"attributes":{"type":"object","description":"A dictionary containing user attributes to add / update in the user profile.\nFor example, to track custom attributes of different data types like string, numeric, boolean, and date, pass the following payload where points are a number, expiry_date is a date type attribute, and super_user is a boolean attribute.\n\n> **Note:**\n> * \"id\", \"_id\", and \"\" keywords are blocked and not to be used as user attribute names.\n> * You can not use \"moe_\" as a prefix while naming user attributes. It is a system prefix and using it might result in periodic blacklisting without prior communication.\n> For other attributes that are not listed below, use the key-value pairs that you intend to use.\n\n**Array Support**\n If you want to pass an attribute in an array, the appropriate syntax for that is: \n ```json\n \"Array_attributeName\":[\"abc\",\"123\"]\n ```\n**Update Array Attributes**\n To update an existing array attribute rather than overwrite it, use `addValueToArrayField` and `removeValueFromArrayField` inside the `attributes` object of a Track User call:\n ```json\n {\n \"customer_id\": \"user123\",\n \"attributes\": {\n \"addValueToArrayField\": { \"favorite_categories\": [\"shoes\", \"bags\"] },\n \"removeValueFromArrayField\": { \"favorite_categories\": [\"hats\"] }\n }\n }\n ```\n * `addValueToArrayField` appends the given value(s) to an existing array attribute.\n * `removeValueFromArrayField` removes the given value(s) from an existing array attribute.\n * You can't add and remove the same attribute in one call.\n * You can't directly set an attribute and add/remove it in the same call.\n * Reserved MoEngage attributes (e.g. `platforms`) can't be used with these operators.\n","properties":{"u_n":{"type":"string","description":"Full name of the user.","uniqueKey":"attributes.u_n","typeLabel":"string"},"u_fn":{"type":"string","description":"First name of the user.","uniqueKey":"attributes.u_fn","typeLabel":"string"},"u_ln":{"type":"string","description":"Last name of the user.","uniqueKey":"attributes.u_ln","typeLabel":"string"},"u_gd":{"type":"string","description":"Gender of the user.","uniqueKey":"attributes.u_gd","typeLabel":"string"},"u_em":{"type":"string","format":"email","description":"Email Address of the user (Standard).","uniqueKey":"attributes.u_em","typeLabel":"string\u003cemail>"},"u_mb":{"type":"string","description":"Mobile Number of the user (Standard). Example `918888444411`.","uniqueKey":"attributes.u_mb","typeLabel":"string"},"uid":{"type":"string","description":"A unique ID that the app has set for a user. This is a standard attribute where MoEngage provides the name, and the value is provided by the client.","uniqueKey":"attributes.uid","typeLabel":"string"},"u_bd":{"type":"string","format":"date-time","description":"Birthdate of the user in ISO 8601 format (e.g., 2019-05-21T03:47:35Z).","uniqueKey":"attributes.u_bd","typeLabel":"string\u003cdate-time>"},"moe_wa_subscription":{"type":"boolean","description":"WhatsApp subscription status of a user.","uniqueKey":"attributes.moe_wa_subscription","typeLabel":"boolean"},"moe_em_unsub_categories":{"type":"string","description":"Email Unsubscribed Categories. The list of email categories user has unsubscribed.","uniqueKey":"attributes.moe_em_unsub_categories","typeLabel":"string"},"push_preference":{"type":"boolean","description":"Push Opt In Status (iOS).The push permission status of a user on an iOS device.","uniqueKey":"attributes.push_preference","typeLabel":"boolean"},"moe_sub_w":{"type":"boolean","description":"Web Push Subscription Status. The web push subscription status of a user. Use this to find your aggregate subscribers and users who unsubscribed after subscribing once.","uniqueKey":"attributes.moe_sub_w","typeLabel":"boolean"},"moe_spam":{"type":"boolean","description":"Spam. Email Spam Attribute. The emails are not sent to the user when the set value is true.","uniqueKey":"attributes.moe_spam","typeLabel":"boolean"},"moe_unsubscribe":{"type":"boolean","description":"Unsubscribe. Email Unsubscribe Attribute. Emails are not sent to the user when the set value is true.","uniqueKey":"attributes.moe_unsubscribe","typeLabel":"boolean"},"moe_hard_bounce":{"type":"boolean","description":"Hard Bounce. Email Hard Bounce Attribute. The emails are not sent to the user when the set value is true.","uniqueKey":"attributes.moe_hard_bounce","typeLabel":"boolean"},"moe_sms_subscription":{"type":"string","description":"SMS Subscription Status. An attribute which stores the SMS subscription status of the user. This will be used to see if a user is reachable based on certain values of the attribute.","uniqueKey":"attributes.moe_sms_subscription","typeLabel":"string"},"moe_email_optin_status":{"type":"string","enum":["DOUBLE_OPTED_IN","OPTED_OUT","OPT_IN_PENDING"],"description":"Email Opt-in Status. An attribute that stores the opt-in status of the user for the email channel. Supported values are: \n* `DOUBLE_OPTED_IN`\n* `OPTED_OUT`\n* `OPT_IN_PENDING`\n","uniqueKey":"attributes.moe_email_optin_status","typeLabel":"enum\u003cstring>"},"publisher_name":{"type":"string","description":"Publisher Name. The name of the campaign publisher. This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.publisher_name","typeLabel":"string"},"campaign_name":{"type":"string","description":"Campaign Name. The name of the campaign. This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.campaign_name","typeLabel":"string"},"u_l_a":{"type":"integer","format":"int64","description":"Last Seen. Time in epoch format (for example, `1767092989259`). This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.u_l_a","typeLabel":"integer\u003cint64>"},"cr_t":{"type":"integer","format":"int64","description":"First Seen. Time in epoch format (for example, `1767092989259`). This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.cr_t","typeLabel":"integer\u003cint64>"},"geo":{"type":"string","description":"Geolocation of the user as a string of latitude and longitude (for example, `88.90 89.00`).","uniqueKey":"attributes.geo","typeLabel":"string"},"moe_gaid":{"type":"string","description":"Google Advertising ID (Android). A unique, resettable identifier provided by Google for ad tracking and attribution on Android devices. This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.moe_gaid","typeLabel":"string"},"advertising_identifier":{"type":"string","description":"Advertising Identifier (iOS \u0026 Windows). A unique alphanumeric string used for ad tracking on iOS (IDFA) and Windows devices. This standard attribute can only be created through the Track User API and cannot be updated later.","uniqueKey":"attributes.advertising_identifier","typeLabel":"string"}},"additionalProperties":true,"example":{"name":"John","points":20,"expiry_date":"2020-05-31T03:47:35Z","super_user":true,"user_persona":"browsers"},"uniqueKey":"attributes","typeLabel":"object"},"platforms":{"type":"array","description":"List of dictionaries with the associated platforms out of ANDROID, iOS, and web and their status.","items":{"type":"object","properties":{"platform":{"type":"string","enum":["ANDROID","iOS","web"],"uniqueKey":"platforms.items.[INDEX].platform","typeLabel":"enum\u003cstring>"},"active":{"type":"string","enum":["true","false"],"uniqueKey":"platforms.items.[INDEX].active","typeLabel":"enum\u003cstring>"}},"uniqueKey":"platforms.items.[INDEX]","typeLabel":"object"},"uniqueKey":"platforms","typeLabel":"object[]"},"unset_attributes":{"type":"array","description":"Use this field to clear one or more existing user attributes. Add the name of each attribute you want to unset as a string in the array. Each name must exactly match the attribute name in your workspace. Attribute names that are not found are skipped without an error.\n\n```json\n {\n \"customer_id\": \"user123\",\n \"unset_attributes\": [\"first_name\", \"loyalty_tier\"]\n }\n```\n* System/reserved attributes are protected and can't be unset this way.\n","items":{"type":"string","uniqueKey":"unset_attributes.items.[INDEX]","typeLabel":"string"},"uniqueKey":"unset_attributes","typeLabel":"string[]"}},"uniqueKey":"","typeLabel":"User · object"},"examples":{"Standard Example":{"title":"Standard Example","value":{"type":"customer","customer_id":"[email protected]","attributes":{"name":"JohnDoe","first_name":"John","platforms":[{"platform":"ANDROID","active":"true"}]}}},"User property as Date/Time":{"title":"User property as Date/Time","value":{"type":"customer","customer_id":"[email protected]","update_existing_only":true,"attributes":{"points":20,"expiry_date":"2020-05-31T03:47:35Z","super_user":true,"user_persona":"browsers","platforms":[{"platform":"ANDROID","active":"true"}]}}},"User property as Array":{"title":"User property as Array","value":{"type":"customer","customer_id":"123","attributes":{"removeValueFromArrayField":{},"addValueToArrayField":{"attribute1":["abc","def"],"attribute2":["a"],"attribute3":["123"]},"platforms":[{"platform":"iOS","active":"true"}]}}},"Unsetting Attributes":{"title":"Unsetting Attributes","value":{"type":"customer","customer_id":"user123","unset_attributes":["first_name","loyalty_tier"]}}},"exampleType":"examples"}},"exampleType":"examples"},"responses":{"b1c28746-b10b-415e-b7a4-8b8e8e6675e0":{"description":"This response is returned when the request is processed successfully.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","description":"This field contains the status of the request and specifies whether the request was successful.","example":"success","uniqueKey":"status","typeLabel":"string"},"message":{"type":"string","example":"Your request has been accepted and will be processed soon.","uniqueKey":"message","typeLabel":"string"}},"uniqueKey":"","typeLabel":"object"},"examples":{"success_response":{"title":"success_response","value":{"status":"success","message":"Your request has been accepted and will be processed soon."}}},"exampleType":"examples"}},"exampleType":"examples"},"bde373a3-93db-41be-aeb6-3fa31376dbfc":{"description":"This response is returned when the required parameters are missing from the request, attributes are not found, and incorrect values are passed.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","description":"This field contains the status of the request and specifies whether the request was a failure.","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"attribute":{"type":"string","description":"The attribute in the payload that caused the error.","uniqueKey":"error.attribute","typeLabel":"string"},"message":{"type":"string","description":"A descriptive error message explaining why the request failed.","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (\"MissingAttributeError\").","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"missing_customer_id":{"title":"missing_customer_id","value":{"status":"fail","error":{"attribute":"customer_id","message":"customer_id is not found in the payload","type":"MissingAttributeError","request_id":"ZbPXtKFL"}}},"empty_customer_id":{"title":"empty_customer_id","value":{"status":"fail","error":{"attribute":"customer_id","message":"customer_id can not be empty Unicode String","type":"MissingAttributeError","request_id":"VgjtLxTu"}}},"array_field_error":{"title":"array_field_error","value":{"status":"fail","error":{"attribute":"addValueToArrayField","message":"Cannot add and remove 'first_name' at the same time","type":"ArrayFieldError","request_id":"WPDAbugh"}}}},"exampleType":"examples"}},"exampleType":"examples"},"4d829247-60d6-4438-bd26-6c085f9b594f":{"description":"This response is returned when the request does not have valid authentication credentials.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"message":{"type":"string","description":"A descriptive error message explaining why the request failed.","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (e.g., Authentication required).","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"auth_error":{"title":"auth_error","value":{"status":"fail","error":{"message":"App Secret key mismatch. Please login to the dashboard to verify key","type":"Authentication required","request_id":"PVUDFisO"}}},"missing_header":{"title":"missing_header","value":{"status":"fail","error":{"message":"Authentication Header Required","type":"Authentication required","request_id":"PisPjGQQ"}}}},"exampleType":"examples"}},"exampleType":"examples"},"a23c5bd8-2219-4336-8968-d167d7732a8a":{"description":"This response is returned when your MoEngage account is suspended or blocked.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"message":{"type":"string","description":"A descriptive error message explaining why the request failed.(e.g., Your account is suspended. Please contact MoEngage team.)","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (e.g., BlockedClient, Account Suspended, Account Temporarily Suspended).","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"account_blocked":{"title":"account_blocked","value":{"status":"fail","error":{"message":"Your account is blocked. Please contact MoEngage team.","type":"BlockedClient","request_id":"Block123"}}},"account_suspended":{"title":"account_suspended","value":{"status":"fail","error":{"message":"Your account is suspended. Please contact MoEngage team.","type":"Account Suspended","request_id":"Susp123"}}},"temp_suspended":{"title":"temp_suspended","value":{"status":"fail","error":{"message":"Your account is temporarily suspended due to payment issues.","type":"Account Temporarily Suspended","request_id":"TempSusp123"}}}},"exampleType":"examples"}},"exampleType":"examples"},"8fe761bb-1be1-4649-b2e7-14426483f823":{"description":"This response is returned when the payload size exceeds 128 KB.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"message":{"type":"string","description":"A descriptive error message explaining why the request failed.","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (e.g., Payload too large).","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"payload_exceeded":{"title":"payload_exceeded","value":{"status":"fail","error":{"message":"Payload size exceeds 128 KB","type":"PayloadTooLarge","request_id":"VFzDwhwt"}}}},"exampleType":"examples"}},"exampleType":"examples"},"034947e7-3ae3-4dac-8576-7fbb135d91c5":{"description":"This response is returned when the number of requests has exceeded the rate limit.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"message":{"type":"string","description":"A descriptive error message explaining why the request failed.","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (e.g., Rate Limits Exceeded).","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"rate_limit":{"title":"rate_limit","value":{"status":"fail","error":{"message":"Rate limit exceeded","type":"RateLimitError","request_id":"onqucLYL"}}}},"exampleType":"examples"}},"exampleType":"examples"},"6325a776-c212-4aed-b21a-e7bd70266b7f":{"description":"This response is returned when the system runs into an unexpected error.","content":{"application/json":{"schema":{"type":"object","properties":{"status":{"type":"string","example":"fail","uniqueKey":"status","typeLabel":"string"},"error":{"type":"object","properties":{"message":{"type":"string","description":"A descriptive error message explaining why the request failed.","uniqueKey":"error.message","typeLabel":"string"},"type":{"type":"string","description":"The type or category of the error (e.g., Server Error).","uniqueKey":"error.type","typeLabel":"string"},"request_id":{"type":"string","description":"A unique identifier for the request, useful for debugging.","uniqueKey":"error.request_id","typeLabel":"string"}},"uniqueKey":"error","typeLabel":"object"}},"uniqueKey":"","typeLabel":"object"},"examples":{"unknown_error":{"title":"unknown_error","value":{"status":"fail","error":{"message":"Internal Server Error","type":"ServerError","request_id":"KovrwJiF"}}}},"exampleType":"examples"}},"exampleType":"examples"}},"security":{"0a8a6282-3380-4bd5-92fc-15578a67160e":{"Basic Auth":{"type":"http","scheme":"basic","description":"Authentication is done via Basic Auth. This requires a base64-encoded string of your credentials in the format 'username:password'.\n\n- **Username**: Use your MoEngage workspace ID (also known as the App ID). You can find it in the MoEngage dashboard at **Settings** > **Account** > **APIs** > **Workspace ID (earlier app id)**.\n- **Password**: Use your API Key, which you can find within the **Data** tile.\n\n**Note**: After you generate and save the Data API Key, DO NOT generate a new key unless there is a security breach. After you generate a different Data API key and save it, the authentication will start failing. You must update your existing data tracking. \n\nFor more information on authentication and getting your credentials, refer [here](https://www.moengage.com/docs/api/introduction#getting-your-credentials).\n\nData APIs also support OAuth 2.0. For more information, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","scopes":[],"schemeName":"Basic Auth"}},"3bebacac-7788-4f88-8f53-83638d02c6ca":{"OAuth 2.0":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"Pass an OAuth 2.0 access token in the `Authorization` header as `Bearer \u003caccess_token>`. OAuth 2.0 must be enabled for your Data APIs on the API Keys dashboard.\n\nTo generate an access token, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","scopes":[],"schemeName":"OAuth 2.0"}}},"servers":{"ffebe152-68b4-42de-b875-b5c185adaee9":{"url":"https://api-{dc}.moengage.com/v1","description":"MoEngage Core API Server","variables":{"dc":{"default":"01","description":"The ‘dc’ in the API Endpoint URL refers to the MoEngage Data Center (DC). MoEngage hosts each customer in a different DC. You can find your DC number and replace the value of ‘dc’ in the URL by referring to the DC and API endpoint mapping [here](/api/introduction#data-centers). Your MoEngage Data Center (DC) can be 01, 02, 03, 04, 05, 06, or 101. "}}}},"processedSecurityOptions":[{"schemes":[{"scheme":{"type":"http","scheme":"basic","description":"Authentication is done via Basic Auth. This requires a base64-encoded string of your credentials in the format 'username:password'.\n\n- **Username**: Use your MoEngage workspace ID (also known as the App ID). You can find it in the MoEngage dashboard at **Settings** > **Account** > **APIs** > **Workspace ID (earlier app id)**.\n- **Password**: Use your API Key, which you can find within the **Data** tile.\n\n**Note**: After you generate and save the Data API Key, DO NOT generate a new key unless there is a security breach. After you generate a different Data API key and save it, the authentication will start failing. You must update your existing data tracking. \n\nFor more information on authentication and getting your credentials, refer [here](https://www.moengage.com/docs/api/introduction#getting-your-credentials).\n\nData APIs also support OAuth 2.0. For more information, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","scopes":[],"schemeName":"Basic Auth"},"schema":{"title":"Basic Auth","type":"object","description":"Authentication is done via Basic Auth. This requires a base64-encoded string of your credentials in the format 'username:password'.\n\n- **Username**: Use your MoEngage workspace ID (also known as the App ID). You can find it in the MoEngage dashboard at **Settings** > **Account** > **APIs** > **Workspace ID (earlier app id)**.\n- **Password**: Use your API Key, which you can find within the **Data** tile.\n\n**Note**: After you generate and save the Data API Key, DO NOT generate a new key unless there is a security breach. After you generate a different Data API key and save it, the authentication will start failing. You must update your existing data tracking. \n\nFor more information on authentication and getting your credentials, refer [here](https://www.moengage.com/docs/api/introduction#getting-your-credentials).\n\nData APIs also support OAuth 2.0. For more information, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","isRequired":true,"properties":{"username":{"type":"string","uniqueKey":"username","isRequired":true,"typeLabel":"string","deprecated":false},"password":{"type":"string","uniqueKey":"password","isRequired":true,"typeLabel":"string","deprecated":false}},"additionalProperties":false,"deprecated":false},"schemeName":"Basic Auth","name":"Authorization"}],"title":"Basic Auth"},{"schemes":[{"scheme":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"Pass an OAuth 2.0 access token in the `Authorization` header as `Bearer \u003caccess_token>`. OAuth 2.0 must be enabled for your Data APIs on the API Keys dashboard.\n\nTo generate an access token, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","scopes":[],"schemeName":"OAuth 2.0"},"schema":{"title":"Bearer Auth","type":"string","isRequired":true,"description":"Pass an OAuth 2.0 access token in the `Authorization` header as `Bearer \u003caccess_token>`. OAuth 2.0 must be enabled for your Data APIs on the API Keys dashboard.\n\nTo generate an access token, refer to [OAuth 2.0](/api/data/data-overview#oauth-2).\n","format":"bearer","typeLabel":"string\u003cbearer>","deprecated":false},"schemeName":"OAuth 2.0","name":"Authorization"}],"title":"OAuth 2.0"}]},"originalFileLocation":"api/data/data.yaml"},"subdomain":"moengage","siteName":"MoEngage","title":"Track User - MoEngage","relatedPagesConfig":{"enabled":false,"limit":3,"mode":"manual"},"contextualStarterQuestions":[{"_id":"69b015bc7104f9460ee447cb","deploymentId":"68bea8f8fe02728a34cf2acf","questionText":"How do I track a new user?","status":"active","generatedBy":"contextual","path":"api/user/track-user","createdAt":"2026-03-10T12:59:40.199Z","updatedAt":"2026-03-10T12:59:40.199Z","__v":0},{"_id":"69b015bc7104f9460ee447cd","deploymentId":"68bea8f8fe02728a34cf2acf","questionText":"Do I need to pass project_code?","status":"active","generatedBy":"contextual","path":"api/user/track-user","createdAt":"2026-03-10T12:59:40.199Z","updatedAt":"2026-03-10T12:59:40.199Z","__v":0},{"_id":"69b015bc7104f9460ee447cc","deploymentId":"68bea8f8fe02728a34cf2acf","questionText":"What's the rate limit for updates?","status":"active","generatedBy":"contextual","path":"api/user/track-user","createdAt":"2026-03-10T12:59:40.199Z","updatedAt":"2026-03-10T12:59:40.199Z","__v":0}],"navMaps":{"firstHrefInVersion":{},"firstHrefInLanguage":{"en":{"href":"/api/user/track-user","matchLevel":0},"ja":{"href":"/ja/api/user/track-user","matchLevel":1}}},"lastModified":"2026-10-15T15:56:59.246Z","originalFileLocation":"api/user/track-user.mdx","locale":"en"},"headHtml":"\u003cscript data-mint-head>(function(){var d=document.documentElement,p=null;if(!p){try{p=localStorage.getItem(\"isDarkMode\")}catch(e){}if(p==='true')p='dark';else if(p==='false')p='light';if(p!=='light'\u0026\u0026p!=='dark'\u0026\u0026p!=='system')p=\"system\"}var r=p==='system'?(matchMedia(\"(prefers-color-scheme: dark)\").matches?'dark':'light'):p;d.classList.remove(r==='dark'?'light':'dark');d.classList.add(r);d.setAttribute(\"data-theme-preference\",p)})();\u003c/script>\u003cmeta data-mint-head name=\"description\" content=\"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\">\u003cmeta data-mint-head name=\"application-name\" content=\"MoEngage\">\u003cmeta data-mint-head name=\"generator\" content=\"Mintlify\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/android-chrome-192x192.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"apple-touch-icon\" type=\"image/png\" sizes=\"180x180\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/apple-touch-icon.png\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/favicon-16x16.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/favicon-32x32.png\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/favicon.ico\" media=\"(prefers-color-scheme: light)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"192x192\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon-dark/android-chrome-192x192.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"16x16\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon-dark/favicon-16x16.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"icon\" type=\"image/png\" sizes=\"32x32\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon-dark/favicon-32x32.png\" media=\"(prefers-color-scheme: dark)\">\u003clink data-mint-head rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon-dark/favicon.ico\" media=\"(prefers-color-scheme: dark)\">\u003cmeta data-mint-head property=\"og:title\" content=\"Track User - MoEngage\">\u003cmeta data-mint-head property=\"og:description\" content=\"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\">\u003cmeta data-mint-head property=\"og:site_name\" content=\"MoEngage\">\u003cmeta data-mint-head property=\"og:url\" content=\"https://moengage.com/docs/api/user/track-user\">\u003cmeta data-mint-head property=\"og:type\" content=\"website\">\u003cmeta data-mint-head property=\"og:image\" content=\"https://moengage.mintlify.site/docs/_mintlify/api/og/v2?division=User\u0026amp;title=Track+User\u0026amp;description=This+API+adds+or+updates+users+and+user+properties+in+MoEngage.+You+can+create+a+new+user%2C+create+new+user+property%2C+or+update+existing+user+properties+of+users\u0026amp;theme=c3ae899dab8a83c2adcd0e76\u0026amp;signature=9a1aef79bcf3ae8d42877319d1295ca08cf19b8804f6cba0d91686cf509bd66f\">\u003cmeta data-mint-head property=\"og:image:width\" content=\"1200\">\u003cmeta data-mint-head property=\"og:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"twitter:card\" content=\"summary_large_image\">\u003cmeta data-mint-head name=\"twitter:title\" content=\"Track User - MoEngage\">\u003cmeta data-mint-head name=\"twitter:description\" content=\"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\">\u003cmeta data-mint-head name=\"twitter:image\" content=\"https://moengage.mintlify.site/docs/_mintlify/api/og/v2?division=User\u0026amp;title=Track+User\u0026amp;description=This+API+adds+or+updates+users+and+user+properties+in+MoEngage.+You+can+create+a+new+user%2C+create+new+user+property%2C+or+update+existing+user+properties+of+users\u0026amp;theme=c3ae899dab8a83c2adcd0e76\u0026amp;signature=9a1aef79bcf3ae8d42877319d1295ca08cf19b8804f6cba0d91686cf509bd66f\">\u003cmeta data-mint-head name=\"twitter:image:width\" content=\"1200\">\u003cmeta data-mint-head name=\"twitter:image:height\" content=\"630\">\u003cmeta data-mint-head name=\"msapplication-config\" content=\"/docs/mintlify-assets/_mintlify/favicons/moengage/FFhO5ttvrbE72kxs/_generated/favicon/browserconfig.xml\">\u003cmeta data-mint-head name=\"apple-mobile-web-app-title\" content=\"MoEngage\">\u003cmeta data-mint-head name=\"msapplication-TileColor\" content=\"#2E69FF\">\u003cmeta data-mint-head name=\"google-site-verification\" content=\"ICNaPDX9oefbF09W1b5_U9PDnlkyfyKSRbIap6_dW6o\">\u003clink data-mint-head rel=\"canonical\" href=\"https://moengage.com/docs/api/user/track-user\">\u003clink data-mint-head rel=\"alternate\" type=\"application/xml\" href=\"/docs/sitemap.xml\">\u003clink data-mint-head rel=\"alternate\" type=\"text/markdown\" href=\"/docs/api/user/track-user.md\">\u003clink data-mint-head rel=\"alternate\" hreflang=\"en\" href=\"https://moengage.com/docs/api/user/track-user\">\u003clink data-mint-head rel=\"alternate\" hreflang=\"ja\" href=\"https://moengage.com/docs/ja/api/user/track-user\">\u003clink data-mint-head rel=\"alternate\" hreflang=\"x-default\" href=\"https://moengage.com/docs/api/user/track-user\">\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@graph\":[{\"@type\":\"Organization\",\"@id\":\"https://moengage.com/#organization\",\"name\":\"MoEngage\",\"url\":\"https://moengage.com\",\"logo\":{\"@type\":\"ImageObject\",\"url\":\"https://mintcdn.com/moengage/VG5pJbeZsDUmdCZM/logo/light.svg?fit=max\u0026auto=format\u0026n=VG5pJbeZsDUmdCZM\u0026q=85\u0026s=28ca5909311cb6ffe01738e1503b5e64\"}},{\"@type\":\"WebSite\",\"@id\":\"https://moengage.com/docs#website\",\"name\":\"MoEngage\",\"url\":\"https://moengage.com/docs\",\"publisher\":{\"@id\":\"https://moengage.com/#organization\"}},{\"@type\":\"WebPage\",\"@id\":\"https://moengage.com/docs/api/user/track-user#webpage\",\"url\":\"https://moengage.com/docs/api/user/track-user\",\"name\":\"Track User\",\"description\":\"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\",\"dateModified\":\"2026-10-15T15:56:59.246Z\",\"isPartOf\":{\"@id\":\"https://moengage.com/docs#website\"},\"breadcrumb\":{\"@id\":\"https://moengage.com/docs/api/user/track-user#breadcrumb\"}},{\"@type\":\"BreadcrumbList\",\"@id\":\"https://moengage.com/docs/api/user/track-user#breadcrumb\",\"itemListElement\":[{\"@type\":\"ListItem\",\"position\":1,\"name\":\"Endpoints\",\"item\":\"https://moengage.com/docs/api/data/data-overview\"},{\"@type\":\"ListItem\",\"position\":2,\"name\":\"Data\",\"item\":\"https://moengage.com/docs/api/data/data-overview\"},{\"@type\":\"ListItem\",\"position\":3,\"name\":\"Track User\",\"item\":\"https://moengage.com/docs/api/user/track-user\"}]},{\"@type\":[\"TechArticle\",\"APIReference\"],\"@id\":\"https://moengage.com/docs/api/user/track-user#apireference\",\"headline\":\"Track User\",\"name\":\"Track User\",\"description\":\"This API adds or updates users and user properties in MoEngage. You can create a new user, create new user property, or update existing user properties of users.\",\"url\":\"https://moengage.com/docs/api/user/track-user\",\"mainEntityOfPage\":{\"@id\":\"https://moengage.com/docs/api/user/track-user#webpage\"},\"dateModified\":\"2026-10-15T15:56:59.246Z\",\"publisher\":{\"@id\":\"https://moengage.com/#organization\"},\"isPartOf\":{\"@id\":\"https://moengage.com/docs#website\"}}]}\u003c/script>\u003cscript data-mint-head type=\"application/ld+json\">{\"@context\":\"https://schema.org\",\"@type\":\"WebSite\",\"name\":\"MoEngage\",\"creator\":{\"@type\":\"Organization\",\"name\":\"Mintlify\",\"url\":\"https://mintlify.com\"}}\u003c/script>","siteName":"MoEngage","nav":{"global":null,"languages":[{"language":"en","tabs":[{"tab":"Home","pages":[{"title":"Home","href":""}]},{"tab":"User Guide","pages":[{"title":"User Guide","href":"/user-guide/introduction"}]},{"tab":"Developer Guide (SDKs)","pages":[{"title":"Developer Guide (SDKs)","href":"/developer-guide/introduction"}]},{"tab":"API Guide","groups":[{"group":"API Documentation","pages":[{"title":"API Documentation","sidebarTitle":"Overview","icon":"rocket","href":"/api/introduction"},{"group":"Authentication","icon":"key","pages":[{"group":"OAuth 2.0","pages":[{"title":"OAuth 2.0 Overview","icon":"file-magnifying-glass","href":"/api/oauth/oauth-overview"},{"title":"Generate Access Token","deprecated":null,"version":null,"openapi":"/api/oauth/oauth.yaml post /v1/oauth/token","href":"/api/oauth/generate-access-token"},{"title":"Refresh Access Token","deprecated":null,"version":null,"openapi":"/api/oauth/oauth.yaml post /v1/oauth/refresh","href":"/api/oauth/refresh-access-token"}]},{"title":"AWS STS Auth","href":"/api/aws-sts/aws-sts-overview"}]},{"title":"Rate Limits","icon":"gauge","href":"/api/rate-limits"}]},{"group":"Endpoints","icon":"code","pages":[{"group":"Data","icon":"database","pages":[{"title":"Data Overview","description":"Manage users, track events, handle devices, and perform bulk data operations.","icon":"file-magnifying-glass","href":"/api/data/data-overview"},{"group":"User","icon":"user","pages":[{"title":"Track User","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customer/{app_id}","href":"/api/user/track-user"},{"title":"Get User","description":"This API facilitates the retrieval of information of users by specifying the user IDs.","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customers/export","href":"/api/user/get-user"},{"title":"Merge Users","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customer/merge","href":"/api/user/merge-users"},{"title":"Delete Users","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /customer/delete","href":"/api/user/delete-users"}]},{"group":"Event","icon":"calendar","pages":[{"title":"Track Event","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /event/{Workspace_ID}","href":"/api/event/track-event"}]},{"group":"Bulk","icon":"layer-group","pages":[{"title":"Bulk Import Users and Events","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /transition/{Workspace_ID}","href":"/api/bulk/bulk-import-users-and-events"}]},{"group":"Device","icon":"mobile","pages":[{"title":"Track Device","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /device/{app_id}","href":"/api/device/track-device"},{"title":"Device Opt-out","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /devices/manage","href":"/api/device/device-opt-out"}]},{"group":"File Import","icon":"file-import","pages":[{"title":"File Import Overview","icon":"file-magnifying-glass","href":"/api/data/file-import-overview"},{"title":"Trigger File Imports","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /fileimports/trigger/{schedule_id}","href":"/api/file-import/trigger-file-imports"},{"title":"Import Details","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /fileimports/import/status","href":"/api/file-import/import-details"},{"title":"Import File Run History","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /fileimports/import/run/history","href":"/api/file-import/import-file-run-history"}]},{"group":"Tracking","icon":"chart-line","pages":[{"title":"Track App Install","deprecated":null,"version":null,"openapi":"/api/data/data.yaml get /installInfo","href":"/api/tracking/track-app-install"}]},{"group":"Utilities","icon":"wrench","pages":[{"title":"Test Connection API","deprecated":null,"version":null,"openapi":"/api/data/data.yaml post /integrations/authentication","href":"/api/utilities/test-connection-api"}]},{"title":"Streams","icon":"webhook","href":"/api/data/moengage-streams"},{"group":"GDPR/CCPA","icon":"shield-check","pages":[{"title":"GDPR or CCPA Overview","icon":"file-magnifying-glass","href":"/api/gdpr-ccpa/gdpr-ccpa-overview"},{"title":"Submit a GDPR / CCPA Data Request","deprecated":null,"version":null,"openapi":"/api/gdpr-ccpa/gdpr-ccpa.yaml post /opengdpr_requests/{appId}","href":"/api/gdpr/submit-a-gdpr-ccpa-data-request"}]}]},{"group":"Business Events","icon":"calendar-check","pages":[{"group":"Business Events (V5)","icon":"bolt","pages":[{"title":"Business Events API (V5): Overview","icon":"bolt","href":"/api/business-events/business-events-v5/business-events-v5-overview"},{"title":"Trigger Business Event (V5)","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-v5/business-events-v5.yaml post /v5/business-events/triggers","href":"/api/business-events/trigger-business-event-v5"},{"title":"List Business Events","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-v5/business-events-v5.yaml get /v5/business-events","href":"/api/business-events/list-business-events"},{"title":"Search Business Events (V5)","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-v5/business-events-v5.yaml post /v5/business-events/search","href":"/api/business-events/search-business-events-v5"}]},{"group":"Business Events (Legacy)","icon":"clock-rotate-left","pages":[{"title":"Business Events API (Legacy): Overview","icon":"clock-rotate-left","href":"/api/business-events/business-events-legacy/business-events-overview"},{"title":"Create Business Event","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-legacy/business-events.yaml post /business_event","href":"/api/business-events/create-business-event"},{"title":"Trigger Business Event","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-legacy/business-events.yaml post /business_event/trigger","href":"/api/business-events/trigger-business-event"},{"title":"Search Business Events","deprecated":null,"version":null,"openapi":"/api/business-events/business-events-legacy/business-events.yaml post /business_event/search","href":"/api/business-events/search-business-events"}]}]},{"group":"Content","icon":"file-lines","pages":[{"group":"Templates","icon":"rectangle-list","pages":[{"group":"Custom In-App Templates","icon":"mobile-screen","pages":[{"title":"In-app Templates Overview","icon":"file-magnifying-glass","href":"/api/in-app-templates/in-app-templates-overview"},{"title":"Create In-app Template","deprecated":null,"version":null,"openapi":"/api/in-app-templates/in-app-templates.yaml post /custom-templates/inapp","href":"/api/in-app-templates/create-in-app-template"},{"title":"Update In-app Template","deprecated":null,"version":null,"openapi":"/api/in-app-templates/in-app-templates.yaml put /custom-templates/inapp","href":"/api/in-app-templates/update-in-app-template"},{"title":"Search In-app Templates","deprecated":null,"version":null,"openapi":"/api/in-app-templates/in-app-templates.yaml post /custom-templates/inapp/search","href":"/api/in-app-templates/search-in-app-templates"}]},{"group":"Custom OSM Templates","icon":"window-restore","pages":[{"title":"OSM Templates Overview","icon":"file-magnifying-glass","href":"/api/osm-templates/osm-templates-overview"},{"title":"Create OSM Template","deprecated":null,"version":null,"openapi":"/api/osm-templates/osm-templates.yaml post /custom-templates/osm","href":"/api/osm-templates/create-osm-template"},{"title":"Update OSM Template","deprecated":null,"version":null,"openapi":"/api/osm-templates/osm-templates.yaml put /custom-templates/osm","href":"/api/osm-templates/update-osm-template"},{"title":"Search OSM Templates","deprecated":null,"version":null,"openapi":"/api/osm-templates/osm-templates.yaml post /custom-templates/osm/search","href":"/api/osm-templates/search-osm-templates"}]},{"group":"Custom SMS Templates","icon":"comment-sms","pages":[{"title":"SMS Templates Overview","icon":"file-magnifying-glass","href":"/api/sms-templates/sms-templates-overview"},{"title":"Create SMS Template","deprecated":null,"version":null,"openapi":"/api/sms-templates/sms-templates.yaml post /custom-templates/sms","href":"/api/sms-templates/create-sms-template"},{"title":"Update SMS Template","deprecated":null,"version":null,"openapi":"/api/sms-templates/sms-templates.yaml put /custom-templates/sms","href":"/api/sms-templates/update-sms-template"},{"title":"Search SMS Templates","deprecated":null,"version":null,"openapi":"/api/sms-templates/sms-templates.yaml post /custom-templates/sms/search","href":"/api/sms-templates/search-sms-templates"}]},{"group":"Custom Email Templates V1","icon":"envelope-open-text","pages":[{"title":"Email Templates (V1) Overview","icon":"file-magnifying-glass","href":"/api/email-templates-1/email-templates-1-overview"},{"title":"Create Email Template (V1)","deprecated":null,"version":null,"openapi":"/api/email-templates-1/email-templates-1.yaml post /email-templates","href":"/api/email-templates/create-email-template-v1"},{"title":"Get All Templates","deprecated":null,"version":null,"openapi":"/api/email-templates-1/email-templates-1.yaml get /email-templates","href":"/api/email-templates/get-all-templates"},{"title":"Get Specific Template","deprecated":null,"version":null,"openapi":"/api/email-templates-1/email-templates-1.yaml get /email-templates/{id}","href":"/api/email-templates/get-specific-template"},{"title":"Update Specific Template","deprecated":null,"version":null,"openapi":"/api/email-templates-1/email-templates-1.yaml put /email-templates/{id}","href":"/api/email-templates/update-specific-template"},{"title":"Bulk Create/Update Templates","deprecated":null,"version":null,"openapi":"/api/email-templates-1/email-templates-1.yaml put /bulk/email-templates","href":"/api/email-templates/bulk-createupdate-templates"}]},{"group":"Custom Email Templates V2","icon":"envelope","pages":[{"title":"Email Templates (V2) Overview","icon":"file-magnifying-glass","href":"/api/email-templates-2/email-templates-2-overview"},{"title":"Create Email Template (V2)","deprecated":null,"version":null,"openapi":"/api/email-templates-2/email-templates-2.yaml post /custom-templates/email","href":"/api/email-templates/create-email-template-v2"},{"title":"Search Email Template","deprecated":null,"version":null,"openapi":"/api/email-templates-2/email-templates-2.yaml post /custom-templates/email/search","href":"/api/email-templates/search-email-template"},{"title":"Update Email Template","deprecated":null,"version":null,"openapi":"/api/email-templates-2/email-templates-2.yaml put /custom-templates/email","href":"/api/email-templates/update-email-template"}]},{"group":"Custom Push Templates","icon":"bell","pages":[{"title":"Push Templates Overview","icon":"file-magnifying-glass","href":"/api/push-templates/push-templates-overview"},{"title":"Create Push Template","deprecated":null,"version":null,"openapi":"/api/push-templates/push-templates.yaml post /custom-templates/push","href":"/api/templates/create-push-template"},{"title":"Update Push Template","deprecated":null,"version":null,"openapi":"/api/push-templates/push-templates.yaml put /custom-templates/push","href":"/api/templates/update-push-template"},{"title":"Search for Push Templates","deprecated":null,"version":null,"openapi":"/api/push-templates/push-templates.yaml post /custom-templates/push/search","href":"/api/templates/search-for-push-templates"}]}]},{"group":"Content Blocks","icon":"cubes","pages":[{"title":"Content Blocks Overview","icon":"file-magnifying-glass","href":"/api/content-blocks/content-blocks-overview"},{"title":"Create Content Block","deprecated":null,"version":null,"openapi":"/api/content-blocks/content-blocks.yaml post /content-blocks","href":"/api/content-blocks/create-content-block"},{"title":"Update Content Block","deprecated":null,"version":null,"openapi":"/api/content-blocks/content-blocks.yaml put /content-blocks","href":"/api/content-blocks/update-content-block"},{"title":"Get Specific Content Blocks","deprecated":null,"version":null,"openapi":"/api/content-blocks/content-blocks.yaml post /content-blocks/get-by-ids","href":"/api/content-blocks/get-specific-content-blocks"},{"title":"Search Content Blocks","deprecated":null,"version":null,"openapi":"/api/content-blocks/content-blocks.yaml post /content-blocks/search","href":"/api/content-blocks/search-content-blocks"}]},{"group":"Content APIs","icon":"plug","pages":[{"title":"Content APIs Overview","icon":"file-magnifying-glass","href":"/api/content-apis/content-apis-overview"},{"title":"List Content APIs","deprecated":null,"version":null,"openapi":"/api/content-apis/content-apis.yaml get /v5/content-apis","href":"/api/content-apis/list-content-apis"},{"title":"Test Content API","deprecated":null,"version":null,"openapi":"/api/content-apis/content-apis.yaml post /v5/content-apis/{id}/test","href":"/api/content-apis/test-content-api"}]},{"group":"Locales","icon":"language","pages":[{"title":"Locales Overview","icon":"file-magnifying-glass","href":"/api/locales/locales-overview"},{"title":"List Locales","deprecated":null,"version":null,"openapi":"/api/locales/locales.yaml get /v5/locales","href":"/api/locales/list-locales"}]},{"group":"Recommendations","icon":"wand-magic-sparkles","pages":[{"title":"Recommendations Overview","icon":"file-magnifying-glass","href":"/api/recommendations/recommendations-overview"},{"title":"Fetch All Recommendations","deprecated":null,"version":null,"openapi":"/api/recommendations/recommendations.yaml get /recommendations","href":"/api/recommendations/fetch-all-recommendations"},{"title":"Fetch Recommendation Details","deprecated":null,"version":null,"openapi":"/api/recommendations/recommendations.yaml get /recommendations/{recommendation_id}","href":"/api/recommendations/fetch-recommendation-details"},{"title":"Fetch Recommendation Results","deprecated":null,"version":null,"openapi":"/api/recommendations/recommendations.yaml post /recommendations/{recommendation_id}/items","href":"/api/recommendations/fetch-recommendation-results"}]},{"group":"Coupons","icon":"ticket","pages":[{"title":"Coupon Management Overview","icon":"file-magnifying-glass","href":"/api/coupons/coupons-overview"},{"title":"Create a Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml post /coupon-list","href":"/api/coupon-lists/create-a-coupon-list"},{"title":"Fetch All Coupon Lists","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml get /coupon-list","href":"/api/coupon-lists/fetch-all-coupon-lists"},{"title":"Fetch Coupon List Details","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml get /coupon-list/{coupon_list_id}","href":"/api/coupon-lists/fetch-coupon-list-details"},{"title":"Update a Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml patch /coupon-list/{coupon_list_id}","href":"/api/coupon-lists/update-a-coupon-list"},{"title":"Activate Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml put /coupon-list/{coupon_list_id}/activate","href":"/api/coupon-lists/activate-coupon-list"},{"title":"Archive a Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml put /coupon-list/{coupon_list_id}/archive","href":"/api/coupon-lists/archive-a-coupon-list"},{"title":"Upload a Coupon File to the Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml post /coupon-list/{coupon_list_id}/files","href":"/api/coupon-files/upload-a-coupon-file-to-the-coupon-list"},{"title":"Fetch All Coupon Files From Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml get /coupon-list/{coupon_list_id}/files","href":"/api/coupon-files/fetch-all-coupon-files-from-coupon-list"},{"title":"Fetch a Coupon File from Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml get /coupon-list/{coupon_list_id}/files/{coupon_file_id}","href":"/api/coupon-files/fetch-a-coupon-file-from-coupon-list"},{"title":"Delete a Coupon File from the Coupon List","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml delete /coupon-list/{coupon_list_id}/files/{coupon_file_id}","href":"/api/coupon-files/delete-a-coupon-file-from-the-coupon-list"},{"title":"Generate Usage Report","deprecated":null,"version":null,"openapi":"/api/coupons/coupons.yaml post /coupon-list/{coupon_list_id}/usage-report","href":"/api/reports/generate-usage-report"}]},{"group":"Catalog","icon":"box","pages":[{"title":"Catalog Overview","icon":"file-magnifying-glass","href":"/api/catalog/catalog-overview"},{"title":"Create Catalog","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml post /catalog","href":"/api/catalog/create-catalog"},{"title":"Add Catalog Attributes","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml patch /catalog/{catalog_id}/attributes","href":"/api/catalog/add-catalog-attributes"},{"title":"Add Items","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml post /catalog/{catalog_id}/items","href":"/api/items/add-items"},{"title":"Get Items","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml post /catalog/{catalog_id}/items/search","href":"/api/items/get-items"},{"title":"Update Items","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml patch /catalog/{catalog_id}/items","href":"/api/items/update-items"},{"title":"Delete Items","deprecated":null,"version":null,"openapi":"/api/catalog/catalog.yaml post /catalog/{catalog_id}/items/bulk-delete","href":"/api/items/delete-items"}]}]},{"group":"Flows","icon":"diagram-project","pages":[{"title":"Flows Overview","href":"/api/flows/flows-overview"},{"title":"Search Flows","deprecated":null,"version":null,"openapi":"/api/flows/flows.yaml post /v5/flows/search","href":"/api/flows/search-flows"},{"title":"Get a Single Flow","deprecated":null,"version":null,"openapi":"/api/flows/flows.yaml get /v5/flows/{flow_id}","href":"/api/flows/get-a-single-flow"},{"title":"Get a Specific Version of a Flow","deprecated":null,"version":null,"openapi":"/api/flows/flows.yaml get /v5/flows/{flow_id}/versions/{version_id}","href":"/api/flows/get-a-specific-version-of-a-flow"},{"title":"Update Flow Status","deprecated":null,"version":null,"openapi":"/api/flows/flows.yaml patch /v5/flows/{flow_id}/status","href":"/api/flows/update-flow-status"}]},{"group":"Offerings","icon":"gift","pages":[{"title":"Offerings Overview","icon":"gift","href":"/api/offerings/offerings-overview"},{"title":"List Offerings","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml get /v5/offers","href":"/api/public-offerings/list-offerings"},{"title":"Get Offering","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml get /v5/offers/{offer_id}","href":"/api/public-offerings/get-offering"},{"title":"Create Offering","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml post /v5/offers","href":"/api/public-offerings/create-offering"},{"title":"Update Offering","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml patch /v5/offers/{offer_id}","href":"/api/public-offerings/update-offering"},{"title":"List Offer Templates","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml get /v5/offers/templates","href":"/api/public-offerings/list-offer-templates"},{"title":"Get Offer Template","deprecated":null,"version":null,"openapi":"/api/offerings/offerings.yaml get /v5/offers/templates/{template_id}","href":"/api/public-offerings/get-offer-template"}]},{"group":"Campaigns","icon":"paper-plane","pages":[{"group":"Campaigns","icon":"file-pen","pages":[{"title":"Campaigns Overview","icon":"file-magnifying-glass","href":"/api/campaigns/campaign-draft-overview"},{"title":"Create Campaign Draft (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/campaigns","href":"/api/create-campaigns/create-campaign-draft-v5"},{"title":"Campaign content reference","icon":"layout-template","href":"/api/campaigns/campaign-content-reference"},{"title":"Audience and delivery reference","icon":"users-viewfinder","href":"/api/campaigns/audience-scheduling-delivery-reference"},{"title":"Get Campaign (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml get /v5/campaigns/{campaign_id}","href":"/api/get-campaign-details/get-campaign-v5"},{"title":"Update Campaign (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml patch /v5/campaigns/{campaign_id}","href":"/api/update-campaigns/update-campaign-v5"},{"title":"Validate Campaign (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/campaigns/{campaign_id}/validate","href":"/api/create-campaigns/validate-campaign-v5"},{"title":"Update Campaign Status (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml patch /v5/campaigns/{campaign_id}/status","href":"/api/update-campaigns/update-campaign-status-v5"},{"title":"Search Campaigns (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/campaigns/search","href":"/api/get-campaign-details/search-campaigns-v5"},{"title":"Test Campaign (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/campaigns/test","href":"/api/test-campaigns/test-campaign-v5"},{"title":"Get Campaign Meta (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/campaigns/meta","href":"/api/get-campaign-details/get-campaign-meta-v5"},{"title":"Personalized Preview (V5)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaign-draft.yaml post /v5/personalizations/previews","href":"/api/personalized-preview/personalized-preview-v5"}]},{"group":"Campaigns (Legacy)","icon":"paper-plane","pages":[{"title":"Campaigns (Legacy) Overview","icon":"file-magnifying-glass","href":"/api/campaigns/campaigns-overview"},{"title":"Create Campaign","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns","href":"/api/create-campaigns/create-campaign"},{"title":"Update Campaign (V1 — Legacy)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml patch /campaigns/{campaign_id}","href":"/api/update-campaigns/update-campaign-v1-—-legacy"},{"title":"Search Campaigns","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns/search","href":"/api/get-campaign-details/search-campaigns"},{"title":"V1 vs. V5 Search Campaigns: Behavioral Differences","href":"/api/campaigns/search-campaigns-v5-migration"},{"title":"Test Campaign","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns/test","href":"/api/test-campaigns/test-campaign"},{"title":"Personalized Preview","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /personalization/preview","href":"/api/test-campaigns/personalized-preview"},{"title":"Get Campaign Meta (V1 — Legacy)","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns/meta","href":"/api/get-campaign-details/get-campaign-meta-v1-—-legacy"},{"title":"Change Campaign Status","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns/status","href":"/api/update-campaigns/change-campaign-status"},{"title":"Get Child Campaigns","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml post /campaigns/{parent_campaign_id}/executions","href":"/api/get-campaign-details/get-child-campaigns"},{"title":"Update Global Control Group","deprecated":null,"version":null,"openapi":"/api/campaigns/campaigns.yaml put /global-control-group/users","href":"/api/update-campaigns/update-global-control-group"}]},{"group":"Campaign Report and Stats","icon":"chart-bar","pages":[{"title":"Campaign Stats and Reports Overview","icon":"file-magnifying-glass","href":"/api/stats-report/stats-report-overview"},{"title":"Get Campaign Stats","deprecated":null,"version":null,"openapi":"/api/stats-report/stats-report.yaml post /core-services/v1/campaign-stats","href":"/api/stats/get-campaign-stats"},{"title":"Download Campaign Report","deprecated":null,"version":null,"openapi":"/api/stats-report/stats-report.yaml get /campaign_reports/rest_api/{APP_ID}/{FILENAME}","href":"/api/campaign-reports/download-campaign-report"}]}]},{"group":"Analyze","icon":"chart-line","tag":"NEW","pages":[{"group":"Dashboards","icon":"objects-column","pages":[{"title":"Custom Dashboards Overview","icon":"file-magnifying-glass","href":"/api/analytics/analytics-overview"},{"title":"List Dashboards","deprecated":null,"version":null,"openapi":"/api/analytics/analytics.yaml get /v5/analytics/dashboards","href":"/api/dashboards/list-dashboards"},{"title":"Get Dashboard Charts","deprecated":null,"version":null,"openapi":"/api/analytics/analytics.yaml get /v5/analytics/dashboards/{dashboard_id}/charts","href":"/api/dashboards/get-dashboard-charts"},{"title":"Get Chart Data","deprecated":null,"version":null,"openapi":"/api/analytics/analytics.yaml get /v5/analytics/dashboards/{dashboard_id}/charts/{chart_id}","href":"/api/dashboards/get-chart-data"}]},{"group":"Analytics","icon":"chart-mixed","pages":[{"title":"Analytics Query APIs Overview","icon":"chart-mixed","href":"/api/analytics-query/analytics-query-overview"},{"title":"Register a Behavior Query","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml post /v5/analytics/behavior","href":"/api/analytics-queries/register-a-behavior-query"},{"title":"Register a Funnels Query","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml post /v5/analytics/funnels","href":"/api/analytics-queries/register-a-funnels-query"},{"title":"Register a Retention Query","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml post /v5/analytics/retention","href":"/api/analytics-queries/register-a-retention-query"},{"title":"Register a Session-Source Query","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml post /v5/analytics/session-source","href":"/api/analytics-queries/register-a-session-source-query"},{"title":"Register a User Analysis Query","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml post /v5/analytics/user-analysis","href":"/api/analytics-queries/register-a-user-analysis-query"},{"title":"Get Query Status","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml get /v5/analytics/query/{request_id}/status","href":"/api/analytics-queries/get-query-status"},{"title":"Get Query Results","deprecated":null,"version":null,"openapi":"/api/analytics-query/analytics-query.yaml get /v5/analytics/query/{request_id}/results","href":"/api/analytics-queries/get-query-results"}]}]},{"group":"Segments","icon":"users","pages":[{"title":"Segments Overview","icon":"file-magnifying-glass","href":"/api/custom-segments/custom-segments-overview"},{"group":"File Segments","icon":"file-csv","pages":[{"title":"Create File Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml post /v2/custom-segments/file-segment","href":"/api/file-segments/create-file-segment"},{"title":"Add Users to File Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml put /v2/custom-segments/file-segment/add-users","href":"/api/file-segments/add-users-to-file-segment"},{"title":"Remove Users from File Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml put /v2/custom-segments/file-segment/remove-users","href":"/api/file-segments/remove-users-from-file-segment"},{"title":"Replace Users from File Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml put /v2/custom-segments/file-segment/replace","href":"/api/file-segments/replace-users-from-file-segment"}]},{"group":"Filter Segments","icon":"filter","pages":[{"title":"List Segments","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml get /v3/custom-segments","href":"/api/filter-segments/list-segments"},{"title":"Create Filter Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml post /v3/custom-segments","href":"/api/filter-segments/create-filter-segment"},{"title":"Get Segment by ID","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml get /v3/custom-segments/{id}","href":"/api/filter-segments/get-segment-by-id"},{"title":"Update Filter Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml patch /v3/custom-segments/{id}","href":"/api/filter-segments/update-filter-segment"}]},{"group":"Cohort Sync","icon":"users-gear","pages":[{"title":"Sync Cohort Members","deprecated":null,"version":null,"openapi":"/api/cohort-audience/cohort-audience.yaml post /v1/integrations/cohortsync","href":"/api/cohort-sync/sync-cohort-members"}]},{"group":"Manage Segments","icon":"sliders","pages":[{"title":"Archive Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml patch /v2/custom-segments/archive","href":"/api/manage-segments/archive-segment"},{"title":"Unarchive Segment","deprecated":null,"version":null,"openapi":"/api/custom-segments/custom-segments.yaml patch /v2/custom-segments/unarchive","href":"/api/manage-segments/unarchive-segment"}]}]},{"group":"Subscriptions","icon":"envelope-circle-check","pages":[{"group":"Email Subscription","icon":"envelope","pages":[{"title":"Email Subscription Overview","icon":"file-magnifying-glass","href":"/api/email-subscription/email-subscription-overview"},{"title":"Bulk Resubscribe Users","deprecated":null,"version":null,"openapi":"/api/email-subscription/email-subscription.yaml post /emails/v1.0/bulk-resubscribe","href":"/api/resubscribe/bulk-resubscribe-users"},{"title":"Update User Email Opt-in Preferences","deprecated":null,"version":null,"openapi":"/api/email-subscription/email-subscription.yaml put /v1.0/opt-in-management/user-preferences","href":"/api/opt-in-management/update-user-email-opt-in-preferences"}]},{"group":"Subscription Categories","icon":"list-check","pages":[{"group":"Subscription Categories (V5)","pages":[{"title":"Subscription Categories (V5)","icon":"file-magnifying-glass","href":"/api/subscription-categories/subscription-categories-v5/subscription-categories-overview-v5"},{"title":"Get Subscription Categories (V5)","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-v5/subscription-categories-v5.yaml get /v5/subscription-categories","href":"/api/subscription-categories/get-subscription-categories-v5"},{"title":"Get Subscription Preferences (V5)","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-v5/subscription-categories-v5.yaml get /v5/subscription-preferences","href":"/api/subscription-preferences/get-subscription-preferences-v5"},{"title":"Update Subscription Preferences (V5)","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-v5/subscription-categories-v5.yaml patch /v5/subscription-preferences","href":"/api/subscription-preferences/update-subscription-preferences-v5"}]},{"group":"Subscription Categories (Legacy)","pages":[{"title":"Subscription Categories (Legacy)","icon":"file-magnifying-glass","href":"/api/subscription-categories/subscription-categories-legacy/subscription-categories-overview-legacy"},{"title":"Get Subscription Preferences","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-legacy/subscription-categories-legacy.yaml get /category-subscription/user-preferences","href":"/api/subscription-preferences/get-subscription-preferences"},{"title":"Update Subscription Preferences","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-legacy/subscription-categories-legacy.yaml put /category-subscription/user-preferences","href":"/api/subscription-preferences/update-subscription-preferences"},{"title":"Bulk Update Subscription Preferences","deprecated":null,"version":null,"openapi":"/api/subscription-categories/subscription-categories-legacy/subscription-categories-legacy.yaml post /category-subscription/user-preferences","href":"/api/subscription-preferences/bulk-update-subscription-preferences"}]}]}]},{"group":"Push","icon":"bell","pages":[{"title":"Push Overview","icon":"file-magnifying-glass","href":"/api/push/push-overview"},{"title":"Push API (V5)","openapi":"api/push/push-v5.yaml POST /v5/push/notifications","href":"/api/push/push-api"},{"title":"Push API (v2.1, Legacy)","openapi":"api/push/push-v2-1.yaml POST /v2.1/transaction/sendpush","href":"/api/push/push-api-v2-1-legacy"},{"title":"Push API (v2, Legacy)","openapi":"api/push/push.yaml POST /transaction/sendpush","href":"/api/push/push-api-v2-legacy"}]},{"group":"Cards","icon":"rectangle-history","pages":[{"title":"Cards Overview","icon":"file-magnifying-glass","href":"/api/cards/cards-overview"},{"title":"Fetch Cards for User","deprecated":null,"version":null,"openapi":"/api/cards/cards.yaml post /cards/fetch","href":"/api/cards/fetch-cards-for-user"},{"title":"Delete Cards for User","deprecated":null,"version":null,"openapi":"/api/cards/cards.yaml delete /cards/delete","href":"/api/cards/delete-cards-for-user"}]},{"group":"Inform","icon":"message","pages":[{"title":"Inform Overview","icon":"file-magnifying-glass","href":"/api/inform/inform-overview"},{"title":"Send Transactional Alert","deprecated":null,"version":null,"openapi":"/api/inform/inform.yaml post /alerts/send","href":"/api/transactional-alerts/send-transactional-alert"}]},{"group":"Live Activities","icon":"circle-play","pages":[{"title":"Live Activities Overview","icon":"file-magnifying-glass","href":"/api/live-activities/live-activities-overview"},{"title":"Start Broadcast Live Activity","deprecated":null,"version":null,"openapi":"/api/live-activities/live-activities.yaml post /live-activity/broadcast/start","href":"/api/live-activities/start-broadcast-live-activity"},{"title":"Update Broadcast Live Activity","deprecated":null,"version":null,"openapi":"/api/live-activities/live-activities.yaml post /live-activity/broadcast/update","href":"/api/live-activities/update-broadcast-live-activity"},{"title":"End Broadcast Live Activity","deprecated":null,"version":null,"openapi":"/api/live-activities/live-activities.yaml post /live-activity/broadcast/end","href":"/api/live-activities/end-broadcast-live-activity"}]},{"group":"Personalize","icon":"bullseye-arrow","pages":[{"title":"Personalize Overview","icon":"file-magnifying-glass","href":"/api/personalize-experience/personalize-overview"},{"title":"Fetch Experience","deprecated":null,"version":null,"openapi":"/api/personalize-experience/personalize-experience.yaml post /experiences/fetch","href":"/api/experiences/fetch-experience"},{"title":"Fetch Experience Metadata","deprecated":null,"version":null,"openapi":"/api/personalize-experience/personalize-experience.yaml get /experiences/metadata","href":"/api/experiences/fetch-experience-metadata"},{"title":"Track Experience Events","deprecated":null,"version":null,"openapi":"/api/personalize-experience/personalize-experience.yaml post /experiences/events","href":"/api/events/track-experience-events"}]},{"group":"Message Archival","icon":"box-archive","pages":[{"title":"Message Archival Overview","icon":"file-magnifying-glass","href":"/api/message-archival/message-archival-overview"},{"title":"View Archived Message","deprecated":null,"version":null,"openapi":"/api/message-archival/message-archival.yaml post /archival/view","href":"/api/message-archival/view-archived-message"}]}]}]},{"tab":"AI \u0026 Intelligence","pages":[{"title":"AI \u0026 Intelligence","href":"/user-guide/ai-and-intelligence/overview"}]},{"tab":"Partner Integrations","pages":[{"title":"Partner Integrations","href":"/partner-guide/introduction"}]},{"tab":"Use Cases","pages":[{"title":"Use Cases","href":"/use-cases/introduction"}]},{"tab":"Release Notes","pages":[{"title":"Release Notes","href":"/release-notes/subscribe-to-release-notes"}]}]},{"language":"ja","pages":[{"title":"ja","href":"/ja/api/user/track-user"}]}]},"basePath":"","title":"Track User - MoEngage","buildId":"dpl_ATnXPMW25DMPUr9VBw6kL6MfBt6T","deploymentId":"dpl_ATnXPMW25DMPUr9VBw6kL6MfBt6T","dynamics":["c2aa737661","2b790eda92","b0f84f53ff","a9bb46feb3"],"chunks":["OpenApiReferenceProvider-CNqlzjVB.js","utils-BqFiXZ79.js","cloneDeep-izs3Hzxb.js","_Uint8Array-BVIqJ90l.js","isObjectLike-C8vmzPEN.js","isArray-Dcu1dQ5t.js","utils-CnR4QBe6.js","toString-BX-iyh8G.js","isSymbol-CSH9U2Gm.js","addUniqueKeysToSchema-BY2ZM1OO.js","snippetPresets-x-8ACO8V.js","style-to-object-BY3JEAdk.js","v4-DIgz8zy6.js","ApiExamples-Ch-SJE05.js","isEqual-BfaiBbcl.js","usePlaygroundInputsStore-CqqG_0NE.js","shallow-BXrZ2b0C.js","getApiPlaygroundDisplay-n7J_wkjq.js","CodeSnippet-CQsp4vyQ.js","CodeSnippets-BfuHqvZx.js","Page-CTxrMSpo.js","getPastedJson-BjrGIK1i.js","icon-7iLZnVOC.js","MethodPill-TBS1m84e.js","DuplicateIcon-BNMrV4Vs.js","createIcon-C5kCqeU2.js","DynamicMarkdown-Bq09mRwR.js","SectionHeading-G4Bflf5Q.js","axios-vUo_bRtp.js","Markdown-BTUds0aX.js","clsx-6wHzaN2_.js","lib-DuNMoZ05.js","lib-B8HbPgcC.js","html-void-elements-mCSPHezU.js","dist-BPypQKlo.js","katex-YMM-FMeD.js","marked.esm-CZWythHk.js","AssistantPageLink-o6bee4ro.js"]}